/*:
* @plugindesc v1.00 Particles Image, Animation Title, Title Motions.
* @author Izyees Fariz
*
* @param ===Image===
* @param List Background
* @desc The list of the image in titles1 folder (without .png and "" marks). Separate by comma.
* @default book,castle,crystal
* 
* @param List Foreground
* @desc The list of the image in titles2 folder (without .png and "" marks). Separate by comma.
* @default floral
*
* @param Particle
* @desc The image name of the particle in system folder (without .png and "" marks).
* @default particle001
*
* @param Light
* @desc The image name of the particle in system folder (without .png and "" marks).
* @default light001
*
* @param ==Background Setting==
* @param BG Is Fade?
* @desc Whether your want the background to be fade (true - false). Default: true
* @default true
*
* @param BG Fade Speed
* @desc The speed of fading per frame. Default: 2
* @default 2
*
* @param BG Fade Delay
* @desc Delay between image. Default: 30
* @default 30
*
* @param BG Max Opacity
* @desc The maxsimum value of the opacity. Default: 255
* @default 255
*
* @param BG Min Opacity
* @desc The minimum value of the opacity (must be 0). Default: 0
* @default 0
*
* @param ==Foreground Setting==
* @param FG Is Fade?
* @desc Whether your want the foreground to be fade (true - false). Default: true
* @default true
*
* @param FG Fade Speed
* @desc The speed of fading per frame. Default: 2
* @default 2
*
* @param FG Fade Delay
* @desc Delay between image. Default: 30
* @default 30
*
* @param FG Max Opacity
* @desc The maxsimum value of the opacity. Default: 255
* @default 255
*
* @param FG Min Opacity
* @desc The minimum value of the opacity (must be 0). Default: 0
* @default 0
*
* @param ==Particle Setting==
* @param Show Particle?
* @desc Whether you want to show the particle or not (true - false). Default: true
* @default true
*
* @param PI Number
* @desc How many particles you want to show up? Default: 30
* @default 30
*
* @param PI Front?
* @desc Determine if you want the particle in front of all layer. Default: true
* @default true
*
* @param PI Is Fade?
* @desc Whether your want the foreground to be fade (true - false). Default: true
* @default true
*
* @param PI Fade Speed
* @desc The speed of fading per frame. Default: 2
* @default 2
-PI Is Flash?
-Whether you want the particle flashing. Default: true
-true
*
* @param PI Throw?
* @desc Whether your want to throw the particles (true - false). Default: true
* @default true
*
* @param PI Dispose?
* @desc Whether you want to dispose the particles or not (true - false). Default: false
* @default false
*
* @param PI Drop Multiple?
* @desc Do you want to drop multiple if you have more than 1 particles?(true - false). Default: false
* @default false
*
* @param PI Throw Multiple?
* @desc Do you want to throw multiple if you have more than 1 particles?(true - false). Default: false
* @default false
*
* @param PI Stack Multiple?
* @desc If Throw Multiple is true, you can stack the throw. (true - false). Default: false
* @default false
*
* @param PI Fade Delay
* @desc Delay when fading, delay time before fade in. Default: 10
* @default 10
*
* @param PI Dispose Delay
* @desc Delay when fading, delay time before dispose. Default: 120
* @default 120
*
* @param PI Max Opacity
* @desc The maxsimum value of the opacity. Default: 255
* @default 255
*
* @param PI Min Opacity
* @desc The minimum value of the opacity. Default: 100
* @default 100
*
* @param PI Direction
* @desc The movement of the particles(x,y). Default: 1,0
* @default 1,1
*
* @param PI Origin Anchor
* @desc Origin of the X,Y Axis. Default: 1,0
* @default 1,0
*
* @param PI Blend Mode
* @desc The blend mode of the particle (0-2). Default: 1
* @default 1
*
* @param PI Angle Speed
* @desc The angle speed of the particles. Default: 0.02
* @default 0.02
*
* @param ==Light Layer==
* @param Show Light Layer?
* @desc Whether you want to show the 3rd layer or not (true - false). Default: false
* @default false
*
* @param LL Is Fade?
* @desc Whether your want the layer to be fade (true - false). Default: true
* @default true
*
* @param LL Fade Speed
* @desc The speed of fading per frame. Default: 2
* @default 2
*
* @param LL Is Flashing?
* @desc Whether you want the layer flashing. Default: true
* @default true
*
* @param LL Out-Flash Delay
* @desc Delay when flashing, delay time before fade out. Default: 10
* @default 10
*
* @param LL Appear Time
* @desc Delay when showing, how long would you like the layers appear?. Default: 120
* @default 120
*
* @param LL In-Flash Delay
* @desc Delay when flashing, delay time before fade in. Default: 10
* @default 10
*
* @param LL Max Opacity
* @desc The maxsimum value of the opacity. Default: 255
* @default 255
*
* @param LL Min Opacity
* @desc The minimum value of the opacity. Default: 100
* @default 100
*
* @param LL Position
* @desc The Position of the layers (x,y,width,height). Default: 0,0,-1,-1
* @default 0,0,-1,-1
*
* @param LL Direction
* @desc The movement of the layer (x,y). Default: 10,0
* @default 10,0
*
*
*
* @help
*  ///////////////////Term & Use/////////////////
* Free to use for commercial or private use as well as you credit me.

* ///////////////////Credits/////////////////
* Soulpour777 - Animated Menu Wallpaper
* Nibelung Valesti - https://www.youtube.com/channel/UCWQj-MDI50Z7J5qW_41EFGw
* Galv's MenuFade for fixing fade.
* 
* ///////////////////Parameters/////////////////
* BG - Background Image
*   The default background image in titles1 folder.
*   You can define more than 1 image to make a slideshow.
*   To make a slideshow, please make sure fade setting is
*   true and fade speed is not 0.
*   The fade speed is the speed of fading. If more bigger,
*   more faster the time to appear.
*   The delay is time to wait before fading. 60 = 1 second.
*   Max opacity is the maximum opacity. If 0, you will not
*   see the image. Max is 255.
*   For Background setting, it's recommended to set the value
*   to 255(maximum). This setting for developer purpose who want
*   to examine this plug-in.
*   Min Opacity is the minimum opacity. Please make sure
*   the minimum opacity is smaller than the maximum opacity
*   to prevent bug or glitch.
*
* FG - Foreground Image
*   The default foreground image in titles2 folder.
*   You can define more than 1 imag. Slideshow is not recommended.
*   or else you will encounter a bug.
*   To make a slideshow, please make sure fade setting is
*   true and fade speed is not 0.
*   The fade speed is the speed of fading. If more bigger,
*   more faster the time to appear.
*   The delay is time to wait before fading. 60 = 1 second.
*   Max opacity is the maximum opacity. If 0, you will not
*   see the image. Max is 255.
*   For Foreground setting, it's recommended to set the value
*   to 255(maximum). This setting for developer purpose who want
*   to examine this plug-in.
*   Min Opacity is the minimum opacity. Please make sure
*   the minimum opacity is smaller than the maximum opacity
*   to prevent bug or glitch.
*
* PI - Particles Image
*   The moving particle or motion image in system folder.
*   By default, the particle is set to true.
*   If you set Front to true, the particle will create at
*   the highest layer. The top layer.
*   If you want the particle fading before poping out,
*   please set fade setting to true.
*   The fade speed is the speed of fading. If more bigger,
*   more faster the time to appear.
*   Throw is like throwing a new particles everytime it disposing.
*   If you set throw to true and dispose to true, the particle
*   then will disappear and never return.
*   If you have more than one particles, Drop Multiple allow
*   you to drop more than one group of particle.
*   If you set to Throw to true, you can also throw multiple
*   Particles. By default the particles will stack.
*   If you set Throw to true, particles will stack in their
*   group.
*   Fade delay is a delay time before the particles fade in.
*   If you set Dispose setting to true, this setting will 
*   allow you to make a delay before the particles recreate.
*   Max opacity is the maximum opacity. If 0, you will not
*   see the image. Max is 255.
*   Min Opacity is the minimum opacity. Please make sure
*   the minimum opacity is smaller than the maximum opacity
*   to prevent bug or glitch.
*   You can set the direction of the particles (x,y)
*   The Origin Anchor setting. Me neither don't know much.
*   The Blend mode of the particle, set 0 to 2.
*   The angle speed of the particle a.k.a. the rotation.
*   
* LL - Light Layer
*   The flashing or motion image in system folder.
*   By default, the light layer is set to false.
*   If you want the light layer fading before poping out,
*   please set fade setting to true.
*   The fade speed is the speed of fading. If more bigger,
*   more faster the time to appear.
*   If you want the light layer flashing, please set flash
*   setting to true.
*   Out-flash delay is the delay(wait time) before the
*   light layer fade out.
*   Appear Time is the frames of the Light Layer will belong.
*   In-flash delay is the delay(wait time) before the
*   light layer fade in.
*   Max opacity is the maximum opacity. If 0, you will not
*   see the image. Max is 255.
*   Min Opacity is the minimum opacity. Please make sure
*   the minimum opacity is smaller than the maximum opacity
*   to prevent bug or glitch.
*   To set the position of the light layer set (x,y,width,height)
*   if you set width and height = -1, it will fit the screen.
*     *Please take note that you can create more than one Light
*      Layer. Separate each setting by ";".
*
*
*
*
*/

var params = PluginManager.parameters('Izy_TitleMotions');

//**********Array**********
var bg_list = params['List Background'].split(/\s*,\s*/).filter(function(value) { return !!value; });
var fg_list = params['List Foreground'].split(/\s*,\s*/).filter(function(value) { return !!value; });

var pi_img_list = params['Particle'].split(/\s*,\s*/).filter(function(value) { return !!value; });
var pi_img_movement = params['PI Direction'].split(/\s*,\s*/).filter(function(value) { return !!value; }) || '1,1';
var pi_img_originAnchor = params['PI Origin Anchor'].split(/\s*,\s*/).filter(function(value) { return !!value; });

var ll_img_list = params['Light'].split(/\s*;\s*/).filter(function(value) { return !!value; });
var ll_img_position = params['LL Position'].split(/\s*;\s*/).filter(function(value) { return !!value; }) || '0,0,-1,-1';
var ll_img_movement = params['LL Direction'].split(/\s;s*/).filter(function(value) { return !!value; }) || '10,10';

var ll_img_wantflashing = params['LL Is Flashing?'].split(";");
var ll_img_String_wantfade = String(params['LL Is Fade?']);
var ll_img_wantfade2 = ll_img_String_wantfade.split(";");
var ll_img_fadespeed = params['LL Fade Speed'].split(/\s*;\s*/).filter(function(value) { return !!value; }) || 2;
var ll_img_flash = params['LL Is Flashing?'].split(";");
var ll_img_outfadedelay = params['LL Out-Flash Delay'].split(/\s*;\s*/).filter(function(value) { return !!value; }) || 10;
var ll_img_appeartime = params['LL Appear Time'].split(/\s*;\s*/).filter(function(value) { return !!value; }) || 120;
var ll_img_infadedelay = params['LL In-Flash Delay'].split(/\s*;\s*/).filter(function(value) { return !!value; }) || 10;
var ll_img_max_opacity = params['LL Max Opacity'].split(/\s*;\s*/).filter(function(value) { return !!value; }) || 255;
var ll_img_min_opacity = params['LL Min Opacity'].split(/\s*;\s*/).filter(function(value) { return !!value; }) || 100;

//**********Value**********
var pi_img_location = String(params['Particle']);
var ll_img_location = String(params['Light']);

var bg_img_wantfade = String(params['BG Is Fade?']) === 'true';
var bg_img_fadespeed = Number(params['BG Fade Speed']);
var bg_img_fadedelay = Number(params['BG Fade Delay']);
var bg_img_max_opacity = Number(params['BG Max Opacity']);
var bg_img_min_opacity = Number(params['BG Min Opacity']);

var fg_img_wantfade = String(params['FG Is Fade?']) === 'true';
var fg_img_fadespeed = Number(params['FG Fade Speed']);
var fg_img_fadedelay = Number(params['FG Fade Delay']);
var fg_img_max_opacity = Number(params['FG Max Opacity']);
var fg_img_min_opacity = Number(params['FG Min Opacity']);

var pi_img_show = String(params['Show Particle?']) === 'true';
var pi_img_number = Number(params['PI Number']);
var pi_img_isfront = String(params['PI Front?']) === 'true';
var pi_img_wantfade = String(params['PI Is Fade?']) === 'true';
var pi_img_fadespeed = Number(params['PI Fade Speed']);
var pi_img_throw = String(params['PI Throw?']) === 'true';
var pi_img_dispose = String(params['PI Dispose?']) === 'true';
var pi_img_dropMultiple = String(params['PI Drop Multiple?']) === 'true';
var pi_img_throwMultiple = String(params['PI Throw Multiple?']) === 'true';
var pi_img_stackMultiple = String(params['PI Stack Multiple?']) === 'true';
var pi_img_fadedelay = Number(params['PI Fade Delay']);
var pi_img_disposedelay = Number(params['PI Dispose Delay']);
var pi_img_max_opacity = Number(params['PI Max Opacity']);
var pi_img_min_opacity = Number(params['PI Min Opacity']);
var pi_img_blendMode = Number(params['PI Blend Mode']);
var pi_img_angleSpeed = Number(params['PI Angle Speed']);

var ll_img_show = String(params['Show Light Layer?']) === 'true';

//**********Alias**********
var alias_st_create = Scene_Title.prototype.create;
var alias_st_update = Scene_Title.prototype.update;
var alias_st_createbg = Scene_Title.prototype.createBackground;
var alias_st_createfore = Scene_Title.prototype.createForeground;
var alias_st_createwindow = Scene_Title.prototype.createWindowLayer;
var alias_st_createcommand = Scene_Title.prototype.createCommandWindow;
var alias_st_centersprite = Scene_Title.prototype.centerSprite;
var alias_st_playtitlemusic = Scene_Title.prototype.playTitleMusic;
var alias_st_startfadein = Scene_Base.prototype.startFadeIn;
var alias_st_fadespeed = Scene_Base.prototype.fadeSpeed;
var alias_st_createFadeSprite = Scene_Base.prototype.createFadeSprite;
//var alias_snapbackground = SceneManager.snapForBackground();

Scene_Title.prototype.particle;

//=============================================================================
// rpg_scenes.js
//=============================================================================

//-----------------------------------------------------------------------------
// Scene_Base
//
// The superclass of all scenes within the game.

Scene_Base.prototype.initialize = function() {
    Stage.prototype.initialize.call(this);
    this._active = false;
    this._fadeSign = 0;
    this._fadeDuration = 0;
    this._fadeSprite = null;
};

Scene_Base.prototype.startFadeIn = function(duration, white) {
    this.createFadeSprite(white);
    this._fadeSign = 1;
    this._fadeDuration = duration || 30;
    this._fadeSprite.opacity = 255;
};

Scene_Base.prototype.startFadeOut = function(duration, white) {
    this.createFadeSprite(white);
    this._fadeSign = -1;
    this._fadeDuration = duration || 30;
    this._fadeSprite.opacity = 0;
};

Scene_MenuBase.prototype.createFadeSprite = function(fadeout) {
    if (!this._fadeSprite) this._fadeSprite = new Sprite();
	if (fadeout) {
		this._fadeSprite.bitmap = SceneManager.backgroundBitmapNoBlur();
	} else {
		this._fadeSprite.bitmap = SceneManager.backgroundBitmap();
	};
	this.addChild(this._fadeSprite);
};
//======================================================
//                 Scene Option
//======================================================


Scene_Options.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
	//Scene_Title.create
	this.createBackground
    this.createOptionsWindow();
};
//-----------------------------------------------------------------------------
// Scene_Title
//
// The scene class of the title screen.

Scene_Title.prototype.create = function() {
    alias_st_create.call(this);
	//this.create_particles();
    //this.createBackground();
    //alias_st_createfore;
    //alias_st_createwindow;
    //alias_st_createcommand;
	if (pi_img_isfront == true) {this.izy_create_particle();}
	this.izy_create_lightLayers();
};

Scene_Title.prototype.start = function() {
    Scene_Base.prototype.start.call(this);
    SceneManager.clearStack();
    alias_st_centersprite(this._backSprite1);
	if (bg_img_wantfade == true) {
		alias_st_centersprite(this._backSprite2);
	}
    //alias_st_centersprite(this._backSprite3);
	alias_st_centersprite(this._backSprite4);
    alias_st_playtitlemusic();
	//alias_st_startfadein(alias_st_fadespeed, true);
    //this.startFadeIn(this.fadeSpeed, false);
	this.startFadeIn(Galv.MF.fadeSpeed)
	//alias_snapbackground;
};
//==========================================
//               Galv's Fix
//==========================================

var Imported = Imported || {};
Imported.Galv_MenuFade = true;

var Galv = Galv || {};        // Galv's main object
Galv.MF = Galv.MF || {};      // Galv's stuff

var Galv_Scene_MenuBase_popScene = Scene_MenuBase.prototype.popScene;
Scene_MenuBase.prototype.popScene = function() {
	if ($gameTemp.fadeScene == this.constructor.name) {
		this.startFadeOut(Galv.MF.fadeSpeed,true);
	};
    Galv_Scene_MenuBase_popScene.call(this);
};
var Galv_Scene_Map_start = Scene_Map.prototype.start;
Scene_Map.prototype.start = function() {
	
	Galv_Scene_Map_start.call(this);
	Galv.MF.fade = true;
};

var Galv_SceneManager_snapForBackground = SceneManager.snapForBackground;
SceneManager.snapForBackground = function() {
    this._backgroundBitmapNoBlur = this.snap(); 
    Galv_SceneManager_snapForBackground.call(this);
};
//==========================================
//              Plugin Start
//==========================================
Scene_Title.prototype.createBackground = function() {
	//background
    this._backSprite1 = new Sprite(ImageManager.loadTitle1(bg_list[Math.randomInt(bg_list.length)]));
	if (bg_img_wantfade == true) {
		this._backSprite2 = new Sprite(ImageManager.loadTitle1(bg_list[Math.randomInt(bg_list.length)]));
	}
	//foreground
	this._backSprite4 = new Sprite(ImageManager.loadTitle2(fg_list[Math.randomInt(fg_list.length)]));
	//Setting1-2
	if (bg_img_wantfade == true) {
		this._backSprite1.opacity = bg_img_min_opacity;
		this._backSprite2.opacity = bg_img_max_opacity;
	} else {
		this._backSprite1.opacity = bg_img_max_opacity;
		//this._backSprite2.opacity = bg_img_max_opacity;
	}
	//Setting4
	this._backSprite4.opacity = fg_img_max_opacity;

	//draw
    this.addChild(this._backSprite1);
	if (bg_img_wantfade == true) {
		this.addChild(this._backSprite2);
	}
	this.addChild(this._backSprite4);
	if (pi_img_isfront == false) {this.izy_create_particle();}
	//this.izy_create_lightLayers();
	//this._backSprite1 = new Sprite(ImageManager.loadTitle1(bg_list[Math.randomInt(bg_list.length)]));
    //var _img_particle = new Sprite;
	//this.addChild(this._img_particle);
	
};
//======================================
// * Create Particles
//======================================
Scene_Title.prototype.izy_create_particle = function () {
	if (pi_img_show) {
		var _img_particle = ImageManager.loadSystem(pi_img_list[Math.randomInt(pi_img_list.length)]);
	    //var _img_particle = ImageManager.loadSystem('particle001');
	    //console.log(_img_particle);
	    this._img_particles = [];
        this._img_particles_data = [];
	    for (i = 0; i < pi_img_number; i++) {
		    this._img_particles.push(new Sprite(_img_particle));
		    this.addChild(this._img_particles[i]);
		    this._img_particles_data[i] = [];
		    this.izy_reset_particles(i);
		    this._img_particles[i].x = Math.floor((Math.random() * Graphics.boxWidth));
            this._img_particles[i].y = Math.floor((Math.random() * Graphics.boxHeight));
		    if (pi_img_wantfade == true) {
			    this._img_particles[i].opacity = pi_img_min_opacity;
		    } else {
			    this._img_particles[i].opacity = pi_img_max_opacity;
		    }
            this._img_particles[i].anchor.x = pi_img_originAnchor[0];
            this._img_particles[i].anchor.y = pi_img_originAnchor[1];
            this._img_particles[i].blendMode = pi_img_blendMode;
		    //this._img_particle = new Sprite(ImageManager.loadSystem(pi_img_list[Math.randomInt(pi_img_list.length)]));
		    //this._img_particle.move(Math.randomInt(Graphics.width),Math.randomInt(Graphics.height));
	    }
	}
}
//==============================
// * Reset Particles
//==============================    
Scene_Title.prototype.izy_reset_particles = function(i) {
    this._img_particles_data[i][0] = Math.floor((Math.random() * 2) * pi_img_movement[0])
    this._img_particles_data[i][1] = Math.floor((Math.random() * 2) * pi_img_movement[1])
    this._img_particles_data[i][2] = ((Math.random() * pi_img_angleSpeed));
	if (pi_img_dropMultiple) {
		//this._img_particles[i].bitmap = pi_img_list[Math.randomInt(pi_img_list.length)];
		this._img_particles[i].bitmap = ImageManager.loadSystem(pi_img_list[Math.randomInt(pi_img_list.length)]);
	}
	if (pi_img_wantfade == true) {
		this._img_particles[i].opacity = pi_img_min_opacity;
	} else {
		this._img_particles[i].opacity = pi_img_max_opacity;
	}
    //this._img_particles[i].opacity = 0;
    this._img_particles[i].x = Math.floor((Math.random() * Graphics.boxWidth));
    var pz = ((Math.random() * 0.5) * 1);
    this._img_particles[i].scale = new PIXI.Point(0.5 + pz, 0.5 + pz);
    if (pi_img_movement[1] < 0) {
        this._img_particles[i].y = Graphics.boxHeight + this._img_particles[i].height * 2;
    }
    else if (pi_img_movement[1] > 0)
    {
        this._img_particles[i].y = -this._img_particles[i].height * 2;
    }
    else {
        this._img_particles[i].y = Math.floor((Math.random() * Graphics.boxHeight));
    }
    if (this._img_particles_data[i][0] == 0 && this._img_particles_data[i][1] == 0) {
        this._img_particles[i].x = -this._img_particles[i].width * 5;
        this._img_particles_data[i][0] = 9999;
        this._img_particles_data[i][1] = 9999;
    };
}
//==============================
// * Reset Particles C
//==============================    
Scene_Title.prototype.izy_reset_particles_c = function(i) {
    if (this._img_particles[i].x < -this._img_particles[i].width * 2 || this._img_particles[i].x > Graphics.boxWidth + this._img_particles[i].width * 2) {return true};
    if (this._img_particles[i].y < -this._img_particles[i].height * 2 || this._img_particles[i].y > Graphics.boxHeight + this._img_particles[i].height * 2 ) {return true};
    return false;
}
//==============================
// * Update Particles
//==============================
Scene_Title.prototype.izy_update_particles = function() {
   for (var i = 0; i < this._img_particles.length; i++) {
        this._img_particles[i].x += this._img_particles_data[i][0];
        this._img_particles[i].y += this._img_particles_data[i][1];
        this._img_particles[i].opacity += 2;
        this._img_particles[i].rotation += this._img_particles_data[i][2];
        if (this.izy_reset_particles_c(i)) { this.izy_reset_particles(i);};
    };
};

//======================================
// * Create Light Layers
//======================================

Scene_Title.prototype.izy_create_lightLayers = function() {
	if (ll_img_show) {
	this._img_lightLayers = [];
	var _img_lightLayers_width = 0;
	var _img_lightLayers_height = 0;
	for (i = 0; i < ll_img_list.length; i++) {
		var ll_img_position_xy = ll_img_position[i].split(/\s*,\s*/).filter(function(value) { return !!value; });
		this._img_lightLayers[i] = new TilingSprite()
		this._img_lightLayers[i].bitmap = ImageManager.loadSystem(ll_img_list[i]);
		if (ll_img_position_xy[2] = -1) {
			_img_lightLayers_width = Graphics.width;
		} else {
			_img_lightLayers_width =  ll_img_position_xy[2];
		}
		if (Boolean(ll_img_wantflashing[i])) {
			ll_img_wantfade2[i] = true;
		}
		if (ll_img_position_xy[3] = -1) {
			_img_lightLayers_height = Graphics.height;
		} else {
			_img_lightLayers_height = ll_img_position_xy[3];
		}
		this._img_lightLayers[i].move(ll_img_position_xy[0], ll_img_position_xy[1], _img_lightLayers_width, _img_lightLayers_height);
		if (Boolean(ll_img_wantfade2[i])) {
			this._img_lightLayers[i].opacity = Number(ll_img_min_opacity[i] || 100);
			ll_isFading_in[i] = true;
		} else {
			this._img_lightLayers[i].opacity = Number(ll_img_max_opacity[i]) || 255;
		}
		ll_total_wait[i] = ll_img_appeartime[i] || 120;
		ll_totalIn_delay[i] = ll_img_infadedelay[i] || 10;
		ll_totalOut_delay[i] = ll_img_outfadedelay[i] || 10;
		//ll_wantFlashing[i] = 
		ll_isWait[i] = true;
		ll_cur_wait[i] = 0;
		ll_curIn_delay[i] = 0;
		ll_curOut_delay[i] = 0;
		ll_img_flash[i] = ll_img_flash[i] == 'true';
		//console.log(Number(ll_img_min_opacity[i]))
		this.addChild(this._img_lightLayers[i])
	}
}
}

//===============Variable1=================
var _cursprite1 = 2;
var _isfadeout1 = false;
var _isdelayed1 = true;
var _totaldelayed1 = bg_img_fadedelay;
//===============Variable2=================
var _cursprite2 = 2;
var _isfadeout2 = false;
var _isdelayed2 = true;
var _totaldelayed2 = fg_img_fadedelay;
//**********Particles Variable**********
var pi_isFading = true;
var pi_isdelayed = false;
var pi_totaldelayed = pi_img_disposedelay;
var pi_isdelayed2 = true;
var pi_totaldelayed2 = pi_img_fadedelay;
//var ll_totalwait = ll_img_appeartime;
if (pi_img_stackMultiple) {
	pi_stackCount = 1; 
}
//===============Variable3=================
var ll_isFading_in = [];
var ll_isWait = [];
var ll_total_wait = [];
var ll_totalOut_delay = [];
var ll_totalIn_delay = [];
var ll_cur_wait = [];
var ll_curOut_delay = [];
var ll_curIn_delay = [];
var ll_wantFlashing = [];


Scene_Options.prototype.terminate = function() {
    Scene_MenuBase.prototype.terminate.call(this);
    ConfigManager.save();
	Scene_Title.prototype.create
};

Scene_Title.prototype.updateBackground = function() {
	this._backSprite1 = new Sprite(ImageManager.loadTitle1(bg_list[Math.randomInt(bg_list.length)]));
};
Scene_Title.prototype.update = function() {
	alias_st_update.call(this);
	//======================================
	//            Background
	//======================================
	if (bg_img_wantfade == true) {
		if (_isdelayed1 == true) {
			if (_totaldelayed1 > 0) {
				_totaldelayed1 -= 1;
			} else {
				_totaldelayed1 = bg_img_fadedelay;
				_isdelayed1 = false;
				//if (_cursprite1 == 1) {return 2} else {if (_cursprite1 == 2) {return 1}}
			}
		} else {
			if (_cursprite1 == 1) {
				//this._backSprite1.x += 1;
				//this._backSprite2.opacity += 1;
				if (this._backSprite2.opacity <= bg_img_max_opacity - 1) {
				    this._backSprite2.opacity += bg_img_fadespeed;
					this._backSprite1.opacity = bg_img_max_opacity;
				} else {
					this._backSprite1.bitmap = ImageManager.loadTitle1(bg_list[Math.randomInt(bg_list.length)]);
					_isdelayed1 = true;
					_cursprite1 = 2;
					//console.log(_isdelayed1)
				}
			} else if (_cursprite1 == 2) {
				if (this._backSprite2.opacity >= bg_img_min_opacity + 1) {
				    this._backSprite2.opacity -= bg_img_fadespeed;
					this._backSprite1.opacity = bg_img_max_opacity;
					
				} else {
					this._backSprite2.bitmap = ImageManager.loadTitle1(bg_list[Math.randomInt(bg_list.length)]);
					_isdelayed1 = true;
					_cursprite1 = 1;
					this._backSprite2.opacity = bg_img_min_opacity;
					//console.log(_isdelayed1);
				}
			}
		}
	}
	//======================================
	//            Foreground
	//======================================
	if (fg_img_wantfade == true) {
		if (_isdelayed2 == true) {
			if (_totaldelayed2 > 0) {
				_totaldelayed2 -= 1;
			} else {
				_totaldelayed2 = fg_img_fadedelay;
				_isdelayed2 = false;
			}
		} else {
			if (_cursprite2 == 1) {
				if (this._backSprite4.opacity <= fg_img_max_opacity - 1) {
				    this._backSprite4.opacity += fg_img_fadespeed;
				} else {
					_isdelayed2 = true;
					_cursprite2 = 2;
				}
			} else if (_cursprite2 == 2) {
				if (this._backSprite4.opacity >= fg_img_min_opacity + 1) {
				    this._backSprite4.opacity -= fg_img_fadespeed;
				} else {
					this._backSprite4.bitmap = ImageManager.loadTitle2(fg_list[Math.randomInt(fg_list.length)]);
					_isdelayed2 = true;
					_cursprite2 = 1;
					this._backSprite4.opacity = fg_img_min_opacity;
				}
			}
		}
	}
	//======================================
	//            Particles
	//======================================
	if (pi_img_throw) {
	if (pi_img_show) {
		if (pi_img_wantfade == true) {
		    if (pi_isdelayed2) {
			    if (pi_totaldelayed2 >= 0) {
				    pi_totaldelayed2 -= 1;
			    } else {
				    if (pi_isFading == true) {
					    for (var a = 0; a < this._img_particles.length; a++) {
						    if (this._img_particles[a].opacity >= pi_img_max_opacity) {	
						    pi_isdelayed = true;
						    pi_isFading = false;
						    pi_isdelayed2 = false;
						    pi_totaldelayed2 = pi_img_fadedelay;
						    } else {
							    this._img_particles[a].opacity += pi_img_fadespeed;
						    }
					    }
			    	}
		    	}
    		}
	    	if (pi_isdelayed) {
    			if (pi_totaldelayed >= 0) {
	    			pi_totaldelayed -= 1;
		    	} else {
			    	if (!pi_isFading) {
				    	if (pi_img_dispose == false) {
					    	for (var j = 0; j < this._img_particles.length; j++) {
						    	if (this._img_particles[j].opacity <= pi_img_min_opacity) {
							        pi_isFading = true;
						            pi_isdelayed = false;
						            pi_totaldelayed = pi_img_disposedelay;
						            pi_isdelayed2 = true;
									if (pi_img_stackMultiple) {
										if (pi_stackCount == 1) {
										pi_stackCount -= 1;
										if (pi_img_throwMultiple) {
											var pi_imageforStack = ImageManager.loadSystem(pi_img_list[Math.randomInt(pi_img_list.length)]);
										    //this._img_particles[j].bitmap = ImageManager.loadSystem(pi_img_list[Math.randomInt(pi_img_list.length)]);
									    }
									}
									} else {
										if (pi_img_throwMultiple) {
											var pi_imageforStack = ImageManager.loadSystem(pi_img_list[Math.randomInt(pi_img_list.length)]);
										    //this._img_particles[j].bitmap = ImageManager.loadSystem(pi_img_list[Math.randomInt(pi_img_list.length)]);
									    }
									}
									this._img_particles[j].bitmap = pi_imageforStack;
									if (j == this._img_particles.length - 1) {
										if (pi_img_stackMultiple) {
											pi_stackCount = 1; 
										}
									}
							    } else {
									 //if (this.izy_reset_particles_c(j)) { this.izy_reset_particles(j);};
								    this._img_particles[j].opacity -= pi_img_fadespeed;
									//console.log('up!')
    							}
	    					}
		    			}
			    	}
			    }
	    	}
	    }
		for (var i = 0; i < this._img_particles.length; i++) {
            this._img_particles[i].x += this._img_particles_data[i][0];
            this._img_particles[i].y += this._img_particles_data[i][1];
            //this._img_particles[i].opacity += pi_img_fadespeed;
            this._img_particles[i].rotation += this._img_particles_data[i][2];
            if (this.izy_reset_particles_c(i)) { this.izy_reset_particles(i);};
        }	
	}	
	} else {
		if (pi_img_show) {
			if (pi_img_wantfade == true) {
		    if (pi_isdelayed2) {
			    if (pi_totaldelayed2 >= 0) {
				    pi_totaldelayed2 -= 1;
			    } else {
				    if (pi_isFading == true) {
					    for (var a = 0; a < this._img_particles.length; a++) {
						    if (this._img_particles[a].opacity >= pi_img_max_opacity) {	
						    //pi_isdelayed = true;
						    //pi_isFading = false;
						    //pi_isdelayed2 = false;
						    //pi_totaldelayed2 = pi_img_fadedelay;
						    } else {
							    this._img_particles[a].opacity += pi_img_fadespeed;
						    }
					    }
			    	}
		    	}
    		}
	    }
		for (var i = 0; i < this._img_particles.length; i++) {
            this._img_particles[i].x += this._img_particles_data[i][0];
            this._img_particles[i].y += this._img_particles_data[i][1];
            //this._img_particles[i].opacity += pi_img_fadespeed;
            this._img_particles[i].rotation += this._img_particles_data[i][2];
            if (this.izy_reset_particles_c(i)) { this.izy_reset_particles(i);};
        }
		}
	}
	
	//======================================
	//            Light Layer
	//======================================

	if (ll_img_show)  {
		for (i = 0; i < ll_img_list.length; i++) {
			if (Boolean(ll_isFading_in[i])) {
				if (Number(ll_curIn_delay[i]) < Number(ll_totalIn_delay[i])) {
					ll_curIn_delay[i] += 1;
				} else {
					if (this._img_lightLayers[i].opacity >= Number(ll_img_max_opacity[i] || 255)) {
						ll_isFading_in[i] = false;
						ll_curIn_delay[i] = 0;
						ll_isWait[i] = "true";
					} else {
						this._img_lightLayers[i].opacity += Number(ll_img_fadespeed[i]);
					}
				}
			}
			if (!Boolean(ll_isFading_in[i])) {
				//console.log("Once False")
				if (Boolean(ll_img_flash[i])) {
					if (Boolean(ll_isWait[i])) {
						if(Number(ll_cur_wait[i]) < Number(ll_total_wait[i])) {
							ll_cur_wait[i] += 1;
						} else {
							ll_isWait[i] = false;
						}
					} 
					if (!Boolean(ll_isWait[i])) {
						if (this._img_lightLayers[i].opacity <= Number(ll_img_min_opacity[i] || 100)) {
							if(Number(ll_curOut_delay[i]) < Number(ll_totalOut_delay[i])) {
								ll_curOut_delay[i] += 1;
							} else {
								ll_isFading_in[i] = true;
						        ll_cur_wait[i] = 0;
								ll_curOut_delay[i] = 0;
							}
						} else {
							this._img_lightLayers[i].opacity -= Number(ll_img_fadespeed[i]);
						}
					}
				}
			}
			var _img_lightLayers_movement = ll_img_movement[i].split(",");		
			this._img_lightLayers[i].origin.x += Number(_img_lightLayers_movement[0]);
			this._img_lightLayers[i].origin.y += Number(_img_lightLayers_movement[1]);
			
			
		}
	}

	
	
	//console.log('update!')
	//console.log(_isdelayed1)
	//console.log(_cursprite1)
	//console.log(this._backSprite2.opacity)
	//this._backSprite1.x += 1;
};